#Crysis CSS Pluggin Written By: J3ff Hoogland
import es, popuplib, gamethread, langlib
langs = ['en']
Version = '0.5.5'
#Begin Events
def player_hurt(ev):
	userid = int(ev['userid'])
	if ev['attacker']: attacker = int(ev['attacker'])
	else: attacker = 0
	damage = int(ev['dmg_health'])
	idpower = Player(userid).GetPower()
	atkpower = Player(attacker).GetPower()
	if idpower == 'Defense':
		if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
			Player(userid).AddHealth(damage*.4)
	elif idpower == 'Stealth':
		Player(userid).Color((255,255,255,90))
		gamethread.delayed(1, Player(userid).Color, (255,255,255,0))
	if atkpower == 'Strength':
		if ev['weapon'] == 'knife': Player(userid).Damage(100, attacker)
		else: Player(userid).Damage(damage*.1, attacker)
	elif atkpower == 'Stealth':
		Player(userid).SetPower('Defense')
		Player(userid).SetArmor(0)
def player_spawn(ev):
	userid = int(ev['userid'])
	Player(userid).SetArmor(125)
	Player(userid).SetPower('Defense')
def player_jump(ev):
	#Thank you SD for high jumping codez
	userid = int(ev['userid'])
	if Player(userid).GetPower() == 'Strength':
		es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s' % tuple([es.getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[%s]' % x) * .5 for x in range(3)]))
#End events
#Handle out menu(s)
def MenuSend():
	MenuBuild(es.getcmduserid())
def MenuSelect(userid, choice, popupid):
	Player(userid).SetPower(choice)
	MenuBuild(userid)
def MenuBuild(id):
	mymenu = popuplib.easymenu('crysis', '_popup_choice', MenuSelect)
	mymenu.settitle(text('power menu title',{'power':Player(id).GetPower()}, Player(id).GetLang()))
	for x in ('Strength','Defense','Speed','Stealth'):
		mymenu.addoption(x,x)
	mymenu.send(id)
def HelpSend():
	help[Player(es.getcmduserid()).GetLang()].send(es.getcmduserid())
def StrengthSend():
	Player(es.getcmduserid()).SetPower('Strength')
def DefenseSend():
	Player(es.getcmduserid()).SetPower('Defense')
def SpeedSend():
	Player(es.getcmduserid()).SetPower('Speed')
def StealthSend():
	Player(es.getcmduserid()).SetPower('Stealth')
#Begin load/unload/loop methods
text = None
def load():
	global text
	text = langlib.Strings(es.getAddonPath('crysis') + '/strings.ini')
	SuitLoop()
	MsgLoop()
	global help
	help = {}
	for x in langs:
		help[x] = popuplib.create('%s help'%x)
		for i in range(1,12):
			help[x].addline(text('help menu line %s'%i,{},x))
	if not es.exists('saycommand', '!power'):
		es.regsaycmd('!power', 'crysis/MenuSend')
	if not es.exists('clientcommand', '!power'):
		es.regclientcmd('!power', 'crysis/MenuSend')
	if not es.exists('saycommand', '!help'):
		es.regsaycmd('!help', 'crysis/HelpSend')
	if not es.exists('clientcommand', '!help'):
		es.regclientcmd('!help', 'crysis/HelpSend')
	for x in ('Strength','Defense','Speed','Stealth'):
		if not es.exists('saycommand', '!%s'%x):
			es.regsaycmd('!%s'%x, 'crysis/%sSend'%x)
		if not es.exists('clientcommand', '!%s'%x):
			es.regclientcmd('!%s'%x, 'crysis/%sSend'%x)
def MsgLoop():
	es.msg('#multi', '#green[Crysis] #defaultUse !help to learn how to play.')
	gamethread.delayedname(30, 'crysis msg', MsgLoop)
def SuitLoop():
	for id in es.getUseridList():
		if not int(es.getplayerprop(id, "CBasePlayer.pl.deadflag")):
			ducked = int(es.getplayerprop(id, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2)
			power = Player(id).GetPower()
			if Player(id).ReturnLastLocation() == es.getplayerlocation(id): lastsame = 1
			else: lastsame = 0
			Player(id).UpdateLocation()
			if power == 'Strength' or power == 'Defense':
				if ducked:
					Player(id).AddArmor(2)
				else:
					Player(id).AddArmor(1)
				if lastsame:
					Player(id).AddArmor(1)
					Player(id).AddHealth(1)
				Player(id).AddHealth(1)
			else:
				if ducked:
					Player(id).AddArmor(-1)
				else:
					Player(id).AddArmor(-2)
				if power == 'Speed':
					if Player(id).GetWeapon() == 'knife':
						Player(id).SetSpeed(3)
						Player(id).AddArmor(-1)
					else:
						Player(id).SetSpeed(2)
				if power == 'Stealth':
					if not lastsame:
						Player(id).AddArmor(-1)
	gamethread.delayedname(1, 'suit loop',SuitLoop)
def unload():
	gamethread.cancelDelayed('suit loop')
	gamethread.cancelDelayed('crysis msg')
#End load/unload/loop methods
#Our main player class
Players = {}
class Player:
	global Players
	def __init__(self, id):
		self.id = int(id)
		if not Players.has_key(self.id):
			Players[self.id] = {}
			Players[self.id]['power'] = 'Strength'
			Players[self.id]['xyz'] = es.getplayerlocation(self.id)
		self.key = Players[self.id]
		self.attributes = es.createplayerlist(self.id)[self.id]
	def GetArmor(self):
		return int(es.getplayerprop(self.id, "CCSPlayer.m_ArmorValue"))
	def SetArmor(self, value):
		es.setplayerprop(self.id, "CCSPlayer.m_ArmorValue", value)
	def AddArmor(self, value):
		if (self.GetArmor()+value) <= 125:
			if (self.GetArmor()+value) >= 0:
				self.SetArmor(self.GetArmor()+value)
			else:
				self.SetArmor(0)
				self.SetPower('Defense')
				es.tell(self.id, '#multi', text('power out',{},self.GetLang()))
		else:
			self.SetArmor(125)
	def AddHealth(self, value):
		if (int(es.getplayerprop(self.id, "CBasePlayer.m_iHealth"))+value) <= 100:
			es.setplayerprop(self.id, 'CBasePlayer.m_iHealth', int(es.getplayerprop(self.id, "CBasePlayer.m_iHealth"))+value)
		else:
			es.setplayerprop(self.id, 'CBasePlayer.m_iHealth', 100)
	def Damage(self, amount, attacker):
		if int(es.getplayerprop(self.id, "CBasePlayer.m_iHealth")) > amount:
			es.setplayerprop(self.id, "CBasePlayer.m_iHealth", int(es.getplayerprop(self.id, "CBasePlayer.m_iHealth"))-amount)
		else:
			es.server.queuecmd('damage %s %s 32 %s'%(self.id, amount, attacker))
	def GetPower(self):
		return self.key['power']
	def SetPower(self, choice):
		self.key['power'] = choice
		es.tell(self.id, '#multi', text('new power',{'power':choice},self.GetLang()))
		if choice == 'Stealth':
			self.Color((255,255,255,0))
			self.SetSpeed(1)
		elif choice == 'Speed':
			if self.GetWeapon() == 'knife':
				self.SetSpeed(3)
			else:
				self.SetSpeed(2)
			self.Color((0,255,0,255))
		elif choice == 'Strength':
			self.Color((255,0,0,255))
			self.SetSpeed(1)
		elif choice == 'Defense':
			self.Color((0,0,255,255))
			self.SetSpeed(1)
	def GetWeapon(self):
		return self.attributes['weapon']
	def SetSpeed(self, value):
		es.setplayerprop(self.id, "CBasePlayer.localdata.m_flLaggedMovementValue", value)
	def UpdateLocation(self):
		self.key['xyz'] = es.getplayerlocation(self.id)
	def ReturnLastLocation(self):
		return self.key['xyz']
	#Thank You playerlib
	def GetLang(self):
		if "language" in self.attributes and self.attributes['language']:
			return langlib.getLangAbbreviation(self.attributes['language']) 
		else:
			return langlib.getDefaultLang()
	def Color(self, value):
		value = map(int, value)
		color = value[0]
		color += value[1] << 8
		color += value[2] << 16
		if len(value) >= 4:
			color += value[3] << 24
		else:
			color += self.get("color")[3] << 24
		if color >= 2**31: color -= 2**32
		oldRenderMode = es.getplayerprop(self.id, "CBaseEntity.m_nRenderMode")
		oldRenderFX = es.getplayerprop(self.id, "CBaseEntity.m_nRenderFX")
		newRenderMode = oldRenderMode | 1
		newRenderFX = oldRenderFX | 256
		es.setplayerprop(self.id, "CBaseEntity.m_nRenderMode", newRenderMode)
		es.setplayerprop(self.id, "CBaseEntity.m_nRenderFX", newRenderFX)
		es.setplayerprop(self.id, "CBaseEntity.m_clrRender", color)